import { ApiProperty } from '@nestjs/swagger';
import { IsNotEmpty, IsString } from 'class-validator';
import { i18nValidationMessage as i18n } from 'nestjs-i18n';
export class EnableBiometricRequestDto {
  @ApiProperty({ example: 'device-id' })
  @IsString({ message: i18n('validation.IsString', { path: 'general', property: 'auth.deviceId' }) })
  @IsNotEmpty({ message: i18n('validation.IsNotEmpty', { path: 'general', property: 'auth.deviceId' }) })
  deviceId!: string;

  @ApiProperty({ example: 'publicKey' })
  @IsString({ message: i18n('validation.IsString', { path: 'general', property: 'auth.publicKey' }) })
  @IsNotEmpty({ message: i18n('validation.IsNotEmpty', { path: 'general', property: 'auth.publicKey' }) })
  publicKey!: string;
}
