import { ApiProperty } from '@nestjs/swagger';
import { User } from '~/auth/entities';
import { ILoginResponse } from '~/auth/interfaces';
import { CustomerResponseDto } from '~/customer/dtos/response';
import { UserResponseDto } from './user.response.dto';

export class LoginResponseDto {
  @ApiProperty()
  accessToken!: string;

  @ApiProperty()
  refreshToken!: string;

  @ApiProperty()
  expiresAt!: Date;

  @ApiProperty({ example: UserResponseDto })
  user!: UserResponseDto;

  @ApiProperty({ example: CustomerResponseDto })
  customer!: CustomerResponseDto;

  constructor(IVerifyUserResponse: ILoginResponse, user: User) {
    this.user = new UserResponseDto(user);
    this.customer = new CustomerResponseDto(user.customer);
    this.accessToken = IVerifyUserResponse.accessToken;
    this.refreshToken = IVerifyUserResponse.refreshToken;
    this.expiresAt = IVerifyUserResponse.expiresAt;
  }
}
