import { Injectable } from '@nestjs/common';
import { InjectRepository } from '@nestjs/typeorm';
import { Repository } from 'typeorm';
import { Device } from '../entities';

@Injectable()
export class DeviceRepository {
  constructor(@InjectRepository(Device) private readonly deviceRepository: Repository<Device>) {}

  findUserDeviceById(deviceId: string, userId: string) {
    return this.deviceRepository.findOne({ where: { deviceId, userId } });
  }

  createDevice(data: Partial<Device>) {
    return this.deviceRepository.save(data);
  }

  updateDevice(deviceId: string, data: Partial<Device>) {
    return this.deviceRepository.update({ deviceId }, data);
  }
}
