import { ConfigService } from '@nestjs/config';
import { TypeOrmModuleOptions } from '@nestjs/typeorm';
import { Environment } from '../enums';

export function buildTypeormOptions(
  config: ConfigService,
  migrations?: TypeOrmModuleOptions['migrations'],
): TypeOrmModuleOptions {
  return {
    type: 'postgres',
    host: config.getOrThrow('DB_HOST'),
    port: +config.getOrThrow('DB_PORT'),
    username: config.getOrThrow('DB_USER'),
    password: config.getOrThrow('DB_PASS'),
    database: config.getOrThrow('DB_NAME'),
    logging: config.getOrThrow<string>('NODE_ENV') === Environment.DEV,
    synchronize: false,
    migrationsRun: config.getOrThrow<string>('MIGRATIONS_RUN') === 'true',
    autoLoadEntities: true,
    migrations,
  };
}
