import { ApiProperty } from '@nestjs/swagger';
import { Customer } from '~/customer/entities';

export class CustomerResponseDto {
  @ApiProperty()
  id!: string;

  @ApiProperty()
  customerStatus!: string;

  @ApiProperty()
  rejectionReason!: string;

  @ApiProperty()
  firstName!: string;

  @ApiProperty()
  lastName!: string;

  @ApiProperty()
  dateOfBirth!: Date;

  @ApiProperty()
  nationalId!: string;

  @ApiProperty()
  nationaIdExpiry!: Date;

  @ApiProperty()
  countryOfResidence!: string;

  @ApiProperty()
  sourceOfIncome!: string;

  @ApiProperty()
  profession!: string;

  @ApiProperty()
  professionType!: string;

  @ApiProperty()
  isPep!: boolean;

  @ApiProperty()
  gender!: string;

  @ApiProperty()
  isJunior!: boolean;

  @ApiProperty()
  isGuardian!: boolean;

  constructor(customer: Customer) {
    this.id = customer.id;
    this.customerStatus = customer.customerStatus;
    this.rejectionReason = customer.rejectionReason;
    this.firstName = customer.firstName;
    this.lastName = customer.lastName;
    this.dateOfBirth = customer.dateOfBirth;
    this.nationalId = customer.nationalId;
    this.nationaIdExpiry = customer.nationaIdExpiry;
    this.countryOfResidence = customer.countryOfResidence;
    this.sourceOfIncome = customer.sourceOfIncome;
    this.profession = customer.profession;
    this.professionType = customer.professionType;
    this.isPep = customer.isPep;
    this.gender = customer.gender;
    this.isJunior = customer.isJunior;
    this.isGuardian = customer.isGuardian;
  }
}
