import { ApiProperty } from '@nestjs/swagger';
import { UserNotificationSettings } from '~/auth/entities';

export class NotificationSettingsResponseDto {
  @ApiProperty()
  isEmailEnabled!: boolean;

  @ApiProperty()
  isPushEnabled!: boolean;

  @ApiProperty()
  isSmsEnabled!: boolean;

  constructor(notificationSettings: UserNotificationSettings) {
    this.isEmailEnabled = notificationSettings.isEmailEnabled;
    this.isPushEnabled = notificationSettings.isPushEnabled;
    this.isSmsEnabled = notificationSettings.isSmsEnabled;
  }
}
