import { MigrationInterface, QueryRunner } from 'typeorm';

export class CreateNotificationSettingsTable1733231692252 implements MigrationInterface {
  name = 'CreateNotificationSettingsTable1733231692252';

  public async up(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.query(
      `CREATE TABLE "user_notification_settings" 
      ("id" uuid NOT NULL DEFAULT uuid_generate_v4(), 
      "is_email_enabled" boolean NOT NULL DEFAULT false, 
      "is_push_enabled" boolean NOT NULL DEFAULT false, 
      "is_sms_enabled" boolean NOT NULL DEFAULT false, 
      "created_at" TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT now(), 
      "updated_at" TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT now(), 
      "user_id" uuid, CONSTRAINT "REL_52182ffd0f785e8256f8fcb4fd" UNIQUE ("user_id"), 
      CONSTRAINT "PK_a195de67d093e096152f387afbd" PRIMARY KEY ("id"))`,
    );
    await queryRunner.query(
      `ALTER TABLE "user_notification_settings" ADD CONSTRAINT "FK_52182ffd0f785e8256f8fcb4fd6" FOREIGN KEY ("user_id") REFERENCES "users"("id") ON DELETE CASCADE ON UPDATE NO ACTION`,
    );
  }

  public async down(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.query(
      `ALTER TABLE "user_notification_settings" DROP CONSTRAINT "FK_52182ffd0f785e8256f8fcb4fd6"`,
    );
    await queryRunner.query(`DROP TABLE "user_notification_settings"`);
  }
}
