import { MigrationInterface, QueryRunner } from 'typeorm';

export class CreateDeviceEntity1733314952318 implements MigrationInterface {
  name = 'CreateDeviceEntity1733314952318';

  public async up(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.query(
      `CREATE TABLE "devices" 
      ("deviceId" character varying(255) NOT NULL, 
      "user_id" uuid NOT NULL, 
      "device_name" character varying, 
      "public_key" character varying, 
      "last_access_on" TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT now(), 
      "created_at" TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT now(), 
      "updated_at" TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT now(), 
      CONSTRAINT "PK_666c9b59efda8ca85b29157152c" PRIMARY KEY ("deviceId"))`,
    );
    await queryRunner.query(
      `ALTER TABLE "devices" ADD CONSTRAINT "FK_5e9bee993b4ce35c3606cda194c" FOREIGN KEY ("user_id") REFERENCES "users"("id") ON DELETE CASCADE ON UPDATE NO ACTION`,
    );
  }

  public async down(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.query(`ALTER TABLE "devices" DROP CONSTRAINT "FK_5e9bee993b4ce35c3606cda194c"`);
    await queryRunner.query(`DROP TABLE "devices"`);
  }
}
