import { MigrationInterface, QueryRunner } from 'typeorm';
import { v4 as uuid } from 'uuid';
import { Document } from '../../document/entities';
import { DocumentType } from '../../document/enums';
const DEFAULT_AVATARS = [
  {
    id: uuid(),
    name: 'vacation',
    extension: '.jpg',
    documentType: DocumentType.DEFAULT_AVATAR,
  },
  {
    id: uuid(),
    name: 'colors',
    extension: '.jpg',
    documentType: DocumentType.DEFAULT_AVATAR,
  },
  {
    id: uuid(),
    name: 'astronaut',
    extension: '.jpg',
    documentType: DocumentType.DEFAULT_AVATAR,
  },
  {
    id: uuid(),
    name: 'pet',
    extension: '.jpg',
    documentType: DocumentType.DEFAULT_AVATAR,
  },
  {
    id: uuid(),
    name: 'disney',
    extension: '.jpg',
    documentType: DocumentType.DEFAULT_AVATAR,
  },
  {
    id: uuid(),
    name: 'clothes',
    extension: '.jpg',
    documentType: DocumentType.DEFAULT_AVATAR,
  },
  {
    id: uuid(),
    name: 'playstation',
    extension: '.jpg',
    documentType: DocumentType.DEFAULT_AVATAR,
  },
  {
    id: uuid(),
    name: 'football',
    extension: '.jpg',
    documentType: DocumentType.DEFAULT_AVATAR,
  },
  {
    id: uuid(),
    name: 'cars',
    extension: '.jpg',
    documentType: DocumentType.DEFAULT_AVATAR,
  },
];
export class SeedDefaultAvatar1733750228289 implements MigrationInterface {
  public async up(queryRunner: QueryRunner): Promise<void> {
    await queryRunner.manager.getRepository(Document).save(DEFAULT_AVATARS);
  }

  public async down(queryRunner: QueryRunner): Promise<void> {
    await DEFAULT_AVATARS.forEach(async (avatar) => {
      await queryRunner.manager
        .getRepository(Document)
        .delete({ name: avatar.name, documentType: avatar.documentType });
    });
  }
}
