import { ApiProperty } from '@nestjs/swagger';
import { IsEnum, IsUUID } from 'class-validator';
import { ThemeColor } from '~/junior/enums';

export class SetThemeRequestDto {
  @ApiProperty({ example: ThemeColor.VIOLET })
  @IsEnum(ThemeColor)
  color!: ThemeColor;

  @ApiProperty({ example: 'fbfre-4f4f-4f4f-4f4f' })
  @IsUUID()
  avatarId!: string;
}
