import { ApiProperty } from '@nestjs/swagger';
import { Junior } from '~/junior/entities';
import { Relationship } from '~/junior/enums';

export class JuniorResponseDto {
  @ApiProperty({ example: 'id' })
  id!: string;

  @ApiProperty({ example: 'fullName' })
  fullName!: string;

  @ApiProperty({ example: 'relationship' })
  relationship!: Relationship;

  @ApiProperty({ example: 'profilePictureId' })
  profilePictureId: string | null;

  constructor(junior: Junior) {
    this.id = junior.id;
    this.fullName = `${junior.customer.firstName} ${junior.customer.lastName}`;
    this.relationship = junior.relationship;
    this.profilePictureId = junior.customer.user.profilePictureId;
  }
}
