import { ApiProperty } from '@nestjs/swagger';
import { Theme } from '~/junior/entities';
import { ThemeColor } from '~/junior/enums';

export class ThemeResponseDto {
  @ApiProperty({ example: '645fds-4f5s4f-4f5s4f-4f5s4f' })
  id!: string;

  @ApiProperty({ example: ThemeColor.BLUE })
  color!: string;

  @ApiProperty({ example: '645fds-4f5s4f-4f5s4f-4f5s4f' })
  avatarId!: string;

  @ApiProperty({ example: '645fds-4f5s4f-4f5s4f-4f5s4f' })
  juniorId!: string;

  constructor(theme: Theme | null) {
    if (theme) {
      this.id = theme.id;
      this.color = theme.color;
      this.avatarId = theme.avatarId;
      this.juniorId = theme.juniorId;
    }
  }
}
