import { BaseEntity, Column, Entity, JoinColumn, ManyToOne, OneToOne, PrimaryGeneratedColumn } from 'typeorm';
import { Document } from '~/document/entities';
import { Junior } from './junior.entity';

@Entity('themes')
export class Theme extends BaseEntity {
  @PrimaryGeneratedColumn('uuid')
  id!: string;

  @Column('varchar', { length: 255, name: 'color' })
  color!: string;

  @Column('uuid', { name: 'avatar_id', nullable: true })
  avatarId!: string;

  @ManyToOne(() => Document, (document) => document.themes, { cascade: true, nullable: true })
  @JoinColumn({ name: 'avatar_id' })
  avatar!: Document;

  @Column('uuid', { name: 'junior_id' })
  juniorId!: string;

  @OneToOne(() => Junior, (junior) => junior.theme, { onDelete: 'CASCADE' })
  @JoinColumn({ name: 'junior_id' })
  junior!: Junior;
}
