import { Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { AuthModule } from '~/auth/auth.module';
import { CustomerModule } from '~/customer/customer.module';
import { JuniorController } from './controllers';
import { Junior, Theme } from './entities';
import { JuniorRepository } from './repositories';
import { JuniorService } from './services';

@Module({
  controllers: [JuniorController],
  providers: [JuniorService, JuniorRepository],
  imports: [TypeOrmModule.forFeature([Junior, Theme]), AuthModule, CustomerModule],
})
export class JuniorModule {}
