import { ApiPropertyOptional } from '@nestjs/swagger';
import { IsOptional, IsUUID } from 'class-validator';
import { i18nValidationMessage as i18n } from 'nestjs-i18n';
export class TaskSubmissionRequestDto {
  @ApiPropertyOptional({ example: '4dsf3-4dsf3-4dsf3-4dsf3', description: 'The Proof id of the task submission' })
  @IsUUID('4', { message: i18n('validation.isUUID', { path: 'general', property: 'task.imageId' }) })
  @IsOptional()
  imageId!: string;
}
