import { ApiProperty, ApiPropertyOptional } from '@nestjs/swagger';
import { IsEnum, IsOptional, IsUUID } from 'class-validator';
import { i18nValidationMessage as i18n } from 'nestjs-i18n';
import { PageOptionsRequestDto } from '~/core/dtos';
import { TaskStatus } from '~/task/enums';
export class TasksFilterOptions extends PageOptionsRequestDto {
  @ApiProperty({ enum: TaskStatus, required: true })
  @IsEnum(TaskStatus, {
    message: i18n('validation.IsEnum', { path: 'general', property: 'task.status' }),
  })
  status?: TaskStatus;

  @ApiPropertyOptional()
  @IsUUID('4', { message: i18n('validation.IsUUID', { path: 'general', property: 'task.juniorId' }) })
  @IsOptional()
  juniorId?: string;
}
