import { ApiProperty } from '@nestjs/swagger';
import { JuniorResponseDto } from '~/junior/dtos/response';
import { Task } from '~/task/entities';
import { TaskSubmission } from '~/task/entities/task-submissions.entity';

export class TaskResponseDto {
  @ApiProperty()
  id!: string;

  @ApiProperty()
  title!: string;

  @ApiProperty()
  description!: string;

  @ApiProperty()
  status!: string;

  @ApiProperty()
  dueDate!: Date;

  @ApiProperty()
  rewardAmount!: number;

  @ApiProperty()
  submission?: TaskSubmission;

  @ApiProperty()
  junior!: JuniorResponseDto;

  @ApiProperty()
  createdAt!: Date;

  @ApiProperty()
  updatedAt!: Date;

  constructor(task: Task) {
    this.id = task.id;
    this.title = task.title;
    this.description = task.description;
    this.status = task.status;
    this.dueDate = task.dueDate;
    this.rewardAmount = task.rewardAmount;
    this.submission = task.submission;
    this.junior = new JuniorResponseDto(task.assignedTo);
    this.createdAt = task.createdAt;
    this.updatedAt = task.updatedAt;
  }
}
