import { Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { TaskController } from './controllers';
import { Task } from './entities';
import { TaskSubmission } from './entities/task-submissions.entity';
import { TaskRepository } from './repositories';
import { TaskService } from './services';

@Module({
  imports: [TypeOrmModule.forFeature([Task, TaskSubmission])],
  controllers: [TaskController],
  providers: [TaskService, TaskRepository],
})
export class TaskModule {}
